import pathlib
from pysondb import db


class DataHandler:
    db_object = None
    db_file_path = str(pathlib.Path.home()) + "/deploy_interact/process_list.json"

    def __init__(self):
        if self.db_object is None:
            self.db_object = db.getDb(self.db_file_path)
        pass

    # store data in local database
    def store_device_process_data(self, process_data=None):
        print("store_process_pid_data")
        self.db_object.add(process_data)

    # update data
    def update_process_data(self, unique_id, process_data=None):
        print("update_data")
        self.db_object.updateById(unique_id, process_data)

    # get data from local database
    def get_device_process_data(self, device_id=None):
        print("get_data_from_db")
        a_dict = self.db_object.getByQuery({"device_serial_id": device_id})
        return a_dict

    def check_device_start(self, device_id=None):
        value = True
        obj = self.db_object.getByQuery({"device_serial_id": device_id})
        print(f"check value {obj}")
        if len(obj) == 0:
            value = False
        return value

    def get_unique_id(self, device_id=None):
        value = False
        obj = self.db_object.getByQuery({"device_serial_id": device_id})
        print(obj)
        if len(obj) > 0:
            obj_id = obj[0]['id']
            return obj_id
        return None

    def remove_all_duplicates(self, device_id=None):
        obj = self.db_object.getByQuery({"device_serial_id": device_id})
        for device in obj:
            obj_id = device['id']
            self.delete_process_data(unique_id=obj_id)
            print(f"Removed {obj_id}")
        pass

    # delete data
    def delete_process_data(self, unique_id):
        print("delete_process_data")
        self.db_object.deleteById(unique_id)
