import pathlib
from command_execution import CommandExecutor
from config_parser import Config
from andriod_execution_process import AndroidCommandExecutor


class StreamMaster:

    def __init__(self):
        config = Config()
        self.env_vars = {
            'AWS_ACCESS_KEY_ID': config.get_aws_access_key_id(),
            'AWS_SECRET_ACCESS_KEY': config.get_aws_secret_access_key(),
            'AWS_DEFAULT_REGION': config.get_aws_default_region(),
            'GST_PLUGIN_PATH': '/usr/local/lib/gstreamer-1.0:',
            'LDFLAGS': '-L/usr/local/opt/ffmpeg@4/lib',
            'CPPFLAGS': '-I/usr/local/opt/ffmpeg@4/include',
            'PKG_CONFIG_PATH': '/usr/local/opt/ffmpeg@4/lib/pkgconfig',
            'LD_LIBRARY_PATH': '/usr/local/opt/openssl/lib:',
            'LIBRARY_PATH': '/usr/local/opt/openssl/lib:'
        }
        pass

    # start kvsWebrtcClientMasterGstSample for iOS
    def start_master_stream(self, channel_name):
        print("kvs gst start")
        # start aws c sdk binary
        # read std out
        input_file_path = str(pathlib.Path.home()) + '/app-testing-controller-stack/controller_interact/channel_handler/input_ios'
        command = [str(pathlib.Path.home()) + '/aws-samples/amazon-kinesis-video-streams-webrtc-sdk-c/build/samples/kvsWebrtcClientMasterGstSample', channel_name, 'iOS','12345', '>', input_file_path]
        print("Result subprocess end")
        executor = CommandExecutor(path=input_file_path, channel=channel_name)
        return_code = executor.execute_command(command=command, channel=channel_name, input_file_path=input_file_path, env_vars=self.env_vars)
        print(f"Return Code: {return_code}")

    # start scrcpy for android
    def start_master_scrcpy(self, channel_name):
        # start aws c sdk binary
        # read std out
        input_file_path = str(pathlib.Path.home()) + '/app-testing-controller-stack/controller_interact/channel_handler/input_android'
        command = [str(pathlib.Path.home()) + f'/aws-samples/amazon-kinesis-video-streams-webrtc-sdk-c/build/samples/kvsWebrtcClientMasterScrcpy {channel_name} > {input_file_path}']
        android_execution_process = AndroidCommandExecutor(channel=channel_name, path=input_file_path)
        android_execution_process.execute_command(command=command, input_file_path=input_file_path, channel=channel_name, env_vars=self.env_vars)
        print("Command Executed")

