import os
import pathlib
from master_app import MasterHandler


class MasterPipe:

    pipe_path = str(pathlib.Path.home()) + "/app-testing-controller-stack/controller_interact/channel_handler/input_K6HQWYM0XM"
    pipe_fd = os.open(pipe_path, os.O_RDONLY)

    def __init__(self):
        self.master_app = MasterHandler()
        pass

    def read_line(self):
        try:
            while True:
                line = os.read(self.pipe_fd, 1024)
                if not line:
                    break
                line = line.decode("utf-8").strip()
                self.master_app.handle_fifo(line)
        except KeyboardInterrupt:
            # Handle the Ctrl-C signal
            print("Pipeline interrupted by user")
        finally:
            os.close(self.pipe_fd)
        pass


if __name__ == '__main__':
    pipe = MasterPipe()
    pipe.read_line()
    pass


